]> git.saurik.com Git - apt.git/blob - test/integration/framework
- try downloading clearsigned InRelease before trying Release.gpg
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 # we all like colorful messages
4 CERROR="\e[1;31m" # red
5 CWARNING="\e[1;33m" # yellow
6 CMSG="\e[1;32m" # green
7 CINFO="\e[1;96m" # light blue
8 CDEBUG="\e[1;94m" # blue
9 CNORMAL="\e[0;39m" # default system console color
10 CDONE="\e[1;32m" # green
11 CPASS="\e[1;32m" # green
12 CFAIL="\e[1;31m" # red
13 CCMD="\e[1;35m" # pink
14
15 msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} ${CNORMAL} " >&2; }
26 msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30 # enable / disable Debugging
31 MSGLEVEL=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34 fi
35 if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38 fi
39 if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
46 fi
47 if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50 fi
51 if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54 fi
55 msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65 }
66
67 runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
76 }
77 aptconfig() { runapt apt-config $*; }
78 aptcache() { runapt apt-cache $*; }
79 aptget() { runapt apt-get $*; }
80 aptftparchive() { runapt apt-ftparchive $*; }
81 aptkey() { runapt apt-key $*; }
82 dpkg() {
83 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
84 }
85 aptitude() {
86 if [ -f ./aptconfig.conf ]; then
87 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
88 elif [ -f ../aptconfig.conf ]; then
89 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
90 else
91 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
92 fi
93 }
94
95 setupenvironment() {
96 TMPWORKINGDIRECTORY=$(mktemp -d)
97 local TESTDIR=$(readlink -f $(dirname $0))
98 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
99 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
100 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
101 local OLDWORKINGDIRECTORY=$(pwd)
102 CURRENTTRAP="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
103 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
104 cd $TMPWORKINGDIRECTORY
105 mkdir rootdir aptarchive keys
106 cd rootdir
107 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
108 mkdir -p var/cache var/lib var/log
109 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
110 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
111 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
112 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
113 else
114 touch var/lib/dpkg/status
115 fi
116 touch var/lib/dpkg/available
117 mkdir -p usr/lib/apt
118 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
119 cd ..
120 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
121 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
122 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
123 fi
124 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
125 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
126 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
127 fi
128 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
129 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
130 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
131 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
132 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
133 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
134 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
135 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
136 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
137 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
138 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
139 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
140 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
141 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
142 export LC_ALL=C
143 msgdone "info"
144 }
145
146 configarchitecture() {
147 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
148 echo "APT::Architecture \"$1\";" > $CONFFILE
149 shift
150 while [ -n "$1" ]; do
151 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
152 shift
153 done
154 }
155
156 setupsimplenativepackage() {
157 local NAME="$1"
158 local ARCH="$2"
159 local VERSION="$3"
160 local RELEASE="${4:-unstable}"
161 local DEPENDENCIES="$5"
162 local DESCRIPTION="$6"
163 local SECTION="${7:-others}"
164 local DISTSECTION
165 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
166 DISTSECTION="main"
167 else
168 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
169 fi
170 local BUILDDIR=incoming/${NAME}-${VERSION}
171 mkdir -p ${BUILDDIR}/debian/source
172 cd ${BUILDDIR}
173 echo "* most suckless software product ever" > FEATURES
174 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
175 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
176
177 * Initial release
178
179 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
180 test -e debian/control || echo "Source: $NAME
181 Section: $SECTION
182 Priority: optional
183 Maintainer: Joe Sixpack <joe@example.org>
184 Build-Depends: debhelper (>= 7)
185 Standards-Version: 3.9.1
186
187 Package: $NAME
188 Architecture: $ARCH" > debian/control
189 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
190 if [ -z "$DESCRIPTION" ]; then
191 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
192 If you find such a package installed on your system,
193 YOU did something horribly wrong! They are autogenerated
194 und used only by testcases for APT and surf no other propose…" >> debian/control
195 else
196 echo "Description: $DESCRIPTION" >> debian/control
197 fi
198 test -e debian/compat || echo "7" > debian/compat
199 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
200 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
201 cd - > /dev/null
202 }
203
204 buildsimplenativepackage() {
205 local NAME="$1"
206 local ARCH="$2"
207 local VERSION="$3"
208 local RELEASE="${4:-unstable}"
209 local DEPENDENCIES="$5"
210 local DESCRIPTION="$6"
211 local SECTION="${7:-others}"
212 local DISTSECTION
213 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
214 DISTSECTION="main"
215 else
216 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
217 fi
218 setupsimplenativepackage "$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
219 buildpackage "incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
220 rm -rf "incoming/${NAME}-${VERSION}"
221 }
222
223 buildpackage() {
224 local BUILDDIR=$1
225 local RELEASE=$2
226 local SECTION=$3
227 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}"
228 cd $BUILDDIR
229 if [ "$ARCH" = "all" ]; then
230 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
231 fi
232 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
233 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
234 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
235 cd - > /dev/null
236 for PKG in $PKGS; do
237 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
238 done
239 for SRC in $SRCS; do
240 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
241 done
242 msgdone "info"
243 }
244
245 buildaptarchive() {
246 if [ -d incoming ]; then
247 buildaptarchivefromincoming $*
248 else
249 buildaptarchivefromfiles $*
250 fi
251 }
252
253 createaptftparchiveconfig() {
254 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
255 if [ -z "$ARCHS" ]; then
256 # the pool is empty, so we will operate on faked packages - let us use the configured archs
257 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
258 fi
259 echo -n 'Dir {
260 ArchiveDir "' >> ftparchive.conf
261 echo -n $(readlink -f .) >> ftparchive.conf
262 echo -n '";
263 CacheDir "' >> ftparchive.conf
264 echo -n $(readlink -f ..) >> ftparchive.conf
265 echo -n '";
266 FileListDir "' >> ftparchive.conf
267 echo -n $(readlink -f pool/) >> ftparchive.conf
268 echo -n '";
269 };
270 Default {
271 Packages::Compress ". gzip bzip2 lzma";
272 Sources::Compress ". gzip bzip2 lzma";
273 Contents::Compress ". gzip bzip2 lzma";
274 };
275 TreeDefault {
276 Directory "pool/";
277 SrcDirectory "pool/";
278 };
279 APT {
280 FTPArchive {
281 Release {
282 Origin "joesixpack";
283 Label "apttestcases";
284 Suite "unstable";
285 Description "repository with dummy packages";
286 Architectures "' >> ftparchive.conf
287 echo -n "$ARCHS" >> ftparchive.conf
288 echo 'source";
289 };
290 };
291 };' >> ftparchive.conf
292 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
293 echo -n 'tree "dists/' >> ftparchive.conf
294 echo -n "$DIST" >> ftparchive.conf
295 echo -n '" {
296 Architectures "' >> ftparchive.conf
297 echo -n "$ARCHS" >> ftparchive.conf
298 echo -n 'source";
299 FileList "' >> ftparchive.conf
300 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
301 echo -n '";
302 SourceFileList "' >> ftparchive.conf
303 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
304 echo -n '";
305 Sections "' >> ftparchive.conf
306 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
307 echo '";
308 };' >> ftparchive.conf
309 done
310 }
311
312 buildaptftparchivedirectorystructure() {
313 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
314 for DIST in $DISTS; do
315 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
316 for SECTION in $SECTIONS; do
317 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
318 for ARCH in $ARCHS; do
319 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
320 done
321 mkdir -p dists/${DIST}/${SECTION}/source
322 mkdir -p dists/${DIST}/${SECTION}/i18n
323 done
324 done
325 }
326
327 insertpackage() {
328 local RELEASE="$1"
329 local NAME="$2"
330 local ARCH="$3"
331 local VERSION="$4"
332 local DEPENDENCIES="$5"
333 local ARCHS="$ARCH"
334 if [ "$ARCHS" = "all" ]; then
335 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
336 fi
337 for BUILDARCH in $ARCHS; do
338 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
339 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
340 touch aptarchive/dists/${RELEASE}/main/source/Sources
341 local FILE="${PPATH}/Packages"
342 echo "Package: $NAME
343 Priority: optional
344 Section: other
345 Installed-Size: 42
346 Maintainer: Joe Sixpack <joe@example.org>
347 Architecture: $ARCH
348 Version: $VERSION
349 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
350 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
351 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
352 If you find such a package installed on your system,
353 YOU did something horribly wrong! They are autogenerated
354 und used only by testcases for APT and surf no other propose…
355 " >> $FILE
356 done
357 }
358
359 buildaptarchivefromincoming() {
360 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
361 cd aptarchive
362 [ -e pool ] || ln -s ../incoming pool
363 [ -e ftparchive.conf ] || createaptftparchiveconfig
364 [ -e dists ] || buildaptftparchivedirectorystructure
365 msgninfo "\tGenerate Packages, Sources and Contents files… "
366 aptftparchive -qq generate ftparchive.conf
367 cd - > /dev/null
368 msgdone "info"
369 generatereleasefiles
370 }
371
372 buildaptarchivefromfiles() {
373 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
374 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
375 msgninfo "\t${line} file… "
376 cat ${line} | gzip > ${line}.gz
377 cat ${line} | bzip2 > ${line}.bz2
378 cat ${line} | lzma > ${line}.lzma
379 msgdone "info"
380 done
381 generatereleasefiles
382 }
383
384 generatereleasefiles() {
385 msgninfo "\tGenerate Release files… "
386 local DATE="${1:-now}"
387 if [ -e aptarchive/dists ]; then
388 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
389 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
390 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
391 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
392 sed -i '/^Date: / a\
393 NotAutomatic: yes' $dir/Release
394 fi
395 done
396 else
397 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
398 fi
399 if [ "$DATE" != "now" ]; then
400 for release in $(find ./aptarchive -name 'Release'); do
401 touch -d "$1" $release
402 done
403 fi
404 msgdone "info"
405 }
406
407 setupdistsaptarchive() {
408 local APTARCHIVE=$(readlink -f ./aptarchive)
409 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
410 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
411 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
412 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
413 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
414 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
415 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
416 msgdone "info"
417 done
418 }
419
420 setupflataptarchive() {
421 local APTARCHIVE=$(readlink -f ./aptarchive)
422 if [ -f ${APTARCHIVE}/Packages ]; then
423 msgninfo "\tadd deb sources.list line… "
424 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
425 msgdone "info"
426 else
427 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
428 fi
429 if [ -f ${APTARCHIVE}/Sources ]; then
430 msgninfo "\tadd deb-src sources.list line… "
431 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
432 msgdone "info"
433 else
434 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
435 fi
436 }
437
438 setupaptarchive() {
439 buildaptarchive
440 if [ -e aptarchive/dists ]; then
441 setupdistsaptarchive
442 else
443 setupflataptarchive
444 fi
445 signreleasefiles
446 msgninfo "\tSync APT's cache with the archive… "
447 aptget update -qq
448 msgdone "info"
449 }
450
451 signreleasefiles() {
452 local SIGNER="${1:-Joe Sixpack}"
453 msgninfo "\tSign archive with $SIGNER key… "
454 local SECKEYS=""
455 for KEY in $(find keys/ -name '*.sec'); do
456 SECKEYS="$SECKEYS --secret-keyring $KEY"
457 done
458 local PUBKEYS=""
459 for KEY in $(find keys/ -name '*.pub'); do
460 PUBKEYS="$PUBKEYS --keyring $KEY"
461 done
462 for RELEASE in $(find aptarchive/ -name Release); do
463 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
464 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
465 done
466 msgdone "info"
467 }
468
469 changetowebserver() {
470 if which weborf > /dev/null; then
471 weborf -xb aptarchive/ 2>&1 > /dev/null &
472 CURRENTTRAP="kill $!; $CURRENTTRAP"
473 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
474 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
475 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
476 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
477 done
478 return 0
479 fi
480 return 1
481 }
482
483 checkdiff() {
484 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
485 if [ -n "$DIFFTEXT" ]; then
486 echo
487 echo "$DIFFTEXT"
488 return 1
489 else
490 return 0
491 fi
492 }
493
494 testfileequal() {
495 local FILE="$1"
496 shift
497 msgtest "Test for correctness of file" "$FILE"
498 if [ -z "$*" ]; then
499 echo -n "" | checkdiff $FILE - && msgpass || msgfail
500 else
501 echo "$*" | checkdiff $FILE - && msgpass || msgfail
502 fi
503 }
504
505 testequal() {
506 local COMPAREFILE=$(mktemp)
507 echo "$1" > $COMPAREFILE
508 shift
509 msgtest "Test for equality of" "$*"
510 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
511 rm $COMPAREFILE
512 }
513
514 testequalor2() {
515 local COMPAREFILE1=$(mktemp)
516 local COMPAREFILE2=$(mktemp)
517 local COMPAREAGAINST=$(mktemp)
518 echo "$1" > $COMPAREFILE1
519 echo "$2" > $COMPAREFILE2
520 shift 2
521 msgtest "Test for equality OR of" "$*"
522 $* 2>&1 1> $COMPAREAGAINST
523 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
524 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
525 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
526 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
527 msgfail )
528 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
529 }
530
531 testshowvirtual() {
532 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
533 local PACKAGE="$1"
534 shift
535 while [ -n "$1" ]; do
536 VIRTUAL="${VIRTUAL}
537 N: Can't select versions from package '$1' as it purely virtual"
538 PACKAGE="${PACKAGE} $1"
539 shift
540 done
541 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
542 VIRTUAL="${VIRTUAL}
543 N: No packages found"
544 local COMPAREFILE=$(mktemp)
545 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
546 eval `apt-config shell ARCH APT::Architecture`
547 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
548 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
549 rm $COMPAREFILE
550 }
551
552 testnopackage() {
553 msgtest "Test for non-existent packages" "apt-cache show $*"
554 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
555 if [ -n "$SHOWPKG" ]; then
556 echo
557 echo "$SHOWPKG"
558 msgfail
559 return 1
560 fi
561 msgpass
562 }
563
564 testdpkginstalled() {
565 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
566 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
567 if [ "$PKGS" != 0 ]; then
568 echo $PKGS
569 dpkg -l $* | grep '^[a-z]'
570 msgfail
571 return 1
572 fi
573 msgpass
574 }
575
576 testdpkgnoninstalled() {
577 msgtest "Test for correctly non-installed package(s) with" "dpkg -l $*"
578 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
579 if [ "$PKGS" != 0 ]; then
580 echo
581 dpkg -l $* | grep '^[a-z]'
582 msgfail
583 return 1
584 fi
585 msgpass
586 }